package com.izouma.nineth.web;
import com.izouma.nineth.domain.PurchaseLevel;
import com.izouma.nineth.service.PurchaseLevelService;
import com.izouma.nineth.dto.PageQuery;
import com.izouma.nineth.exception.BusinessException;
import com.izouma.nineth.repo.PurchaseLevelRepo;
import com.izouma.nineth.utils.ObjUtils;
import com.izouma.nineth.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/purchaseLevel")
@AllArgsConstructor
public class PurchaseLevelController extends BaseController {
    private PurchaseLevelService purchaseLevelService;
    private PurchaseLevelRepo purchaseLevelRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public PurchaseLevel save(@RequestBody PurchaseLevel record) {
        if (record.getId() != null) {
            PurchaseLevel orig = purchaseLevelRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return purchaseLevelRepo.save(orig);
        }
        return purchaseLevelRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<PurchaseLevel> all(@RequestBody PageQuery pageQuery) {
        return purchaseLevelService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public PurchaseLevel get(@PathVariable Long id) {
        return purchaseLevelRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        purchaseLevelRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<PurchaseLevel> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

